diff -ruN qmail-1.03-orig/qmail-qmqpd.c qmail-1.03-ldap-20060201-orig/qmail-qmqpd.c
--- qmail-1.03-orig/qmail-qmqpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-qmqpd.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,26 +1,132 @@
+#include <unistd.h>
 #include "auto_qmail.h"
+#include "byte.h"
 #include "qmail.h"
 #include "received.h"
 #include "sig.h"
+#include "subfd.h"
 #include "substdio.h"
 #include "readwrite.h"
 #include "exit.h"
 #include "now.h"
 #include "fmt.h"
 #include "env.h"
+#include "str.h"
+#ifdef QMQP_COMPRESS
+#include <zlib.h>
+
+z_stream stream;
+char zbuf[4096];
+int percent;
+int compressed = 0;
+extern substdio ssout;
+
+void out(const char *s1, const char *s2, const char *s3)
+{
+  char strnum[FMT_ULONG];
+  unsigned long len;
+
+  len = str_len(s1);
+  if (s2) len += str_len(s2);
+  if (s3) len += str_len(s3);
+  substdio_put(&ssout,strnum,fmt_ulong(strnum,len));
+  substdio_puts(&ssout,":");
+  substdio_puts(&ssout,s1);
+  substdio_puts(subfderr,s1+1);
+  if (s2) { substdio_puts(&ssout,s2); substdio_puts(subfderr,s2); }
+  if (s3) { substdio_puts(&ssout,s3); substdio_puts(subfderr,s3); }
+  substdio_puts(subfderr, "\n");
+  substdio_flush(subfderr);
+  substdio_puts(&ssout,",");
+  substdio_flush(&ssout);
+}
+void compression_init(int avail)
+{
+  stream.zalloc = Z_NULL;
+  stream.zfree = Z_NULL;
+  stream.opaque = Z_NULL;
+  stream.avail_in = avail;
+  stream.next_in = zbuf;
+  if (inflateInit(&stream) != Z_OK) {
+    out("ZInitalizing data compression failed: ", stream.msg, " #(4.3.0)");
+    _exit(111);
+  }
+}
+void compression_done(void)
+{
+  if (stream.avail_out != sizeof(zbuf)) {
+    /* there is some data left, ignore */
+  }
+  if (inflateEnd(&stream) != Z_OK) {
+    out("ZFinishing data compression failed: ", stream.msg, " #(4.3.0)");
+    _exit(111);
+  }
+  percent = 100 - (int)(100.0*stream.total_in/stream.total_out);
+}
+#endif
 
 void resources() { _exit(111); }
+void badproto() { _exit(100); }
 
-int safewrite(fd,buf,len) int fd; char *buf; int len;
+int safewrite(int fd, void *buf, int len)
 {
   int r;
   r = write(fd,buf,len);
   if (r <= 0) _exit(0);
   return r;
 }
-int saferead(fd,buf,len) int fd; char *buf; int len;
+int saferead(int fd, void *buf,int len)
 {
   int r;
+#ifdef QMQP_COMPRESS
+  if (compressed == 0) {
+    int i;
+    char ch;
+    r = read(0,zbuf,len);
+    if (r <= 0) _exit(0);
+    for (i = 0; i < r; i++) {
+      ch = zbuf[i];
+      if (ch >= '0' && ch <= '9') continue;
+      if (ch == ':') {
+	byte_copy(buf, r, zbuf);
+	compressed = -1;
+	return r;
+      }
+      compressed = 1;
+      compression_init(r);
+      break;
+    }
+  }
+  if (compressed < 0) goto uncompressed;
+  if (compressed == 2) _exit(0);
+  stream.avail_out = len;
+  stream.next_out = buf;
+  do {
+    if (stream.avail_in == 0) {
+      r = read(fd,zbuf,sizeof(zbuf));
+      if (r <= 0) _exit(0); /* XXX ??? */
+      stream.avail_in = r;
+      stream.next_in = zbuf;
+    }
+    r = inflate(&stream, 0);
+    switch (r) {
+    case Z_OK:
+      if (stream.avail_out == 0)
+	return len;
+      break;
+    case Z_STREAM_END:
+      compression_done();
+      compressed = 2;
+      return len - stream.avail_out;
+    default:
+      out("ZReceiving compressed data failed: ", stream.msg, " #(4.3.0)");
+      return -1;
+    }
+    if (stream.avail_out == (unsigned int)len) continue;
+    return len - stream.avail_out;
+  } while (1);
+uncompressed:
+#endif 
   r = read(fd,buf,len);
   if (r <= 0) _exit(0);
   return r;
@@ -47,8 +153,9 @@
 
   for (;;) {
     getbyte(&ch);
-    if (ch == ':') return len;
     if (len > 200000000) resources();
+    if (ch == ':') return len;
+    if (ch < '0' || ch > '9') badproto();
     len = 10 * len + (ch - '0');
   }
 }
@@ -57,17 +164,17 @@
 {
   char ch;
   getbyte(&ch);
-  if (ch != ',') _exit(100);
+  if (ch != ',') badproto();
 }
 
 struct qmail qq;
 
 void identify()
 {
-  char *remotehost;
-  char *remoteinfo;
-  char *remoteip;
-  char *local;
+  const char *remotehost;
+  const char *remoteinfo;
+  const char *remoteip;
+  const char *local;
 
   remotehost = env_get("TCPREMOTEHOST");
   if (!remotehost) remotehost = "unknown";
@@ -78,16 +185,21 @@
   if (!local) local = env_get("TCPLOCALIP");
   if (!local) local = "unknown";
  
-  received(&qq,"QMQP",local,remoteip,remotehost,remoteinfo,(char *) 0);
+#ifdef QMQP_COMPRESS
+  if (compressed > 0)
+    received(&qq,"compressed QMQP",local,remoteip,remotehost,remoteinfo,(char *) 0,(char *) 0,(char *) 0);
+  else
+#endif
+  received(&qq,"QMQP",local,remoteip,remotehost,remoteinfo,(char *) 0,(char *) 0,(char *) 0);
 }
 
-char buf[1000];
+char buf[1000 + 20 + FMT_ULONG];
 char strnum[FMT_ULONG];
 
-int getbuf()
+int getbuf(void)
 {
   unsigned long len;
-  int i;
+  unsigned long i;
 
   len = getlen();
   if (len >= 1000) {
@@ -105,9 +217,9 @@
 
 int flagok = 1;
 
-main()
+int main(int argc, char **argv)
 {
-  char *result;
+  const char *result;
   unsigned long qp;
   unsigned long len;
   char ch;
@@ -116,6 +228,10 @@
   sig_alarmcatch(resources);
   alarm(3600);
 
+#ifdef QMQP_COMPRESS
+  if (env_get("NOCOMPRESS")) compressed = -1;
+#endif
+
   bytesleft = getlen();
 
   len = getlen();
@@ -158,6 +274,17 @@
     len += fmt_ulong(buf + len,(unsigned long) now());
     len += fmt_str(buf + len," qp ");
     len += fmt_ulong(buf + len,qp);
+#ifdef QMQP_COMPRESS
+    if (compressed > 0) {
+      len += fmt_str(buf + len, " DDC saved ");
+      if (percent < 0) {
+        len += fmt_str(buf + len, "-");
+        percent *= -1;
+      }
+      len += fmt_uint(buf + len, percent);
+      len += fmt_str(buf + len, " percent");
+    }
+#endif
     buf[len] = 0;
     result = buf;
   }
@@ -165,10 +292,13 @@
   if (!flagok)
     result = "Dsorry, I can't accept addresses like that (#5.1.3)";
 
-  substdio_put(&ssout,strnum,fmt_ulong(strnum,(unsigned long) str_len(result)));
+  substdio_put(&ssout,strnum,fmt_uint(strnum,str_len(result)));
   substdio_puts(&ssout,":");
   substdio_puts(&ssout,result);
+  substdio_puts(subfderr,result + 1);
+  substdio_puts(subfderr, "\n");
+  substdio_flush(subfderr);
   substdio_puts(&ssout,",");
   substdio_flush(&ssout);
-  _exit(0);
+  return 0;
 }
diff -ruN qmail-1.03-orig/qmail-qmqpd.rules qmail-1.03-ldap-20060201-orig/qmail-qmqpd.rules
--- qmail-1.03-orig/qmail-qmqpd.rules	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-qmqpd.rules	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,10 @@
+#
+# QMQP (qmail mail queueing protocol) server rules.
+# QMQP is mainly used in clusters to forward mails. The protocol accepts all
+# mails by default and so it is necessary to disable this service by default.
+# Only allow it for cluster hosts.
+# Currently there are no useful env vars for qmail-qmqpd.
+#
+#192.168.0.2:allow
+:deny
+
diff -ruN qmail-1.03-orig/qmail-qmqpd.sh qmail-1.03-ldap-20060201-orig/qmail-qmqpd.sh
--- qmail-1.03-orig/qmail-qmqpd.sh	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-qmqpd.sh	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,28 @@
+#!/bin/sh
+exec 2>&1
+#
+# QMQP service 
+#
+QMAIL="%QMAIL%"
+ME="`head -1 $QMAIL/control/me`"
+QUSER="qmaild"
+
+PATH="$QMAIL/bin:$PATH"
+
+# source the environemt in ./env
+eval `env - PATH=$PATH envdir ./env awk '\
+	BEGIN { for (i in ENVIRON) \
+		if (i != "PATH") { \
+			printf "export %s=\"%s\"\\n", i, ENVIRON[i] \
+		} \
+	}'`
+
+# enforce some sane defaults
+QUSER=${QUSER:="qmaild"}
+
+exec \
+	envuidgid $QUSER \
+	tcpserver -v -URl $ME -x$QMAIL/control/qmail-qmqpd.cdb \
+	    ${CONCURRENCY:+"-c$CONCURRENCY"} ${BACKLOG:+"-b$BACKLOG"} 0 628 \
+	$QMAIL/bin/qmail-qmqpd
+
diff -ruN qmail-1.03-orig/qmail-qmtpd.c qmail-1.03-ldap-20060201-orig/qmail-qmtpd.c
--- qmail-1.03-orig/qmail-qmtpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-qmtpd.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "stralloc.h"
 #include "substdio.h"
 #include "qmail.h"
@@ -11,11 +12,12 @@
 #include "readwrite.h"
 #include "control.h"
 #include "received.h"
+#include "scan.h"
 
 void badproto() { _exit(100); }
 void resources() { _exit(111); }
 
-int safewrite(fd,buf,len) int fd; char *buf; int len;
+int safewrite(int fd, void *buf, int len)
 {
   int r;
   r = write(fd,buf,len);
@@ -26,7 +28,7 @@
 char ssoutbuf[256];
 substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
 
-int saferead(fd,buf,len) int fd; char *buf; int len;
+int saferead(int fd, void *buf, int len)
 {
   int r;
   substdio_flush(&ssout);
@@ -38,14 +40,15 @@
 char ssinbuf[512];
 substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
 
-unsigned long getlen()
+unsigned long getlen(void)
 {
   unsigned long len = 0;
   char ch;
   for (;;) {
     substdio_get(&ssin,&ch,1);
-    if (ch == ':') return len;
     if (len > 200000000) resources();
+    if (ch == ':') return len;
+    if (ch < '0' || ch > '9') badproto();
     len = 10 * len + (ch - '0');
   }
 }
@@ -57,36 +60,35 @@
   if (ch != ',') badproto();
 }
 
-unsigned int databytes = 0;
-unsigned int bytestooverflow = 0;
+unsigned long databytes = 0;
+unsigned long bytestooverflow = 0;
 struct qmail qq;
 
 char buf[1000];
 char buf2[100];
 
-char *remotehost;
-char *remoteinfo;
-char *remoteip;
-char *local;
+const char *remotehost;
+const char *remoteinfo;
+const char *remoteip;
+const char *local;
 
 stralloc failure = {0};
 
 char *relayclient;
-int relayclientlen;
+unsigned int relayclientlen;
 
-main()
+int main()
 {
   char ch;
-  int i;
+  unsigned int i;
   unsigned long biglen;
   unsigned long len;
   int flagdos;
   int flagsenderok;
   int flagbother;
   unsigned long qp;
-  char *result;
+  const char *result;
   char *x;
-  unsigned long u;
  
   sig_pipeignore();
   sig_alarmcatch(resources);
@@ -99,9 +101,9 @@
   relayclient = env_get("RELAYCLIENT");
   relayclientlen = relayclient ? str_len(relayclient) : 0;
  
-  if (control_readint(&databytes,"control/databytes") == -1) resources();
+  if (control_readulong(&databytes,"control/databytes") == -1) resources();
   x = env_get("DATABYTES");
-  if (x) { scan_ulong(x,&u); databytes = u; }
+  if (x) scan_ulong(x,&databytes);
   if (!(databytes + 1)) --databytes;
  
   remotehost = env_get("TCPREMOTEHOST");
@@ -113,6 +115,7 @@
   if (!local) local = env_get("TCPLOCALIP");
   if (!local) local = "unknown";
  
+  flagdos = 0;
   for (;;) {
     if (!stralloc_copys(&failure,"")) resources();
     flagsenderok = 1;
@@ -130,7 +133,7 @@
     else if (ch == 13) flagdos = 1;
     else badproto();
  
-    received(&qq,"QMTP",local,remoteip,remotehost,remoteinfo,(char *) 0);
+    received(&qq,"QMTP",local,remoteip,remotehost,remoteinfo,(char *) 0,(char *) 0,(char *) 0);
  
     /* XXX: check for loops? only if len is big? */
  
@@ -192,8 +195,9 @@
         if (!biglen) badproto();
         substdio_get(&ssin,&ch,1);
         --biglen;
-        if (ch == ':') break;
         if (len > 200000000) resources();
+        if (ch == ':') break;
+	if (ch < '0' || ch > '9') badproto();
         len = 10 * len + (ch - '0');
       }
       if (len >= biglen) badproto();
@@ -265,4 +269,6 @@
  
     /* ssout will be flushed when we read from the network again */
   }
+  /* NOTREACHED */
+  return 0;
 }
diff -ruN qmail-1.03-orig/qmail-qread.c qmail-1.03-ldap-20060201-orig/qmail-qread.c
--- qmail-1.03-orig/qmail-qread.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-qread.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "stralloc.h"
 #include "substdio.h"
 #include "subfd.h"
@@ -20,9 +21,9 @@
 
 void die(n) int n; { substdio_flush(subfdout); _exit(n); }
 
-void warn(s1,s2) char *s1; char *s2;
+void warn(s1,s2) const char *s1; const char *s2;
 {
- char *x;
+ const char *x;
  x = error_str(errno);
  substdio_puts(subfdout,s1);
  substdio_puts(subfdout,s2);
@@ -105,7 +106,7 @@
 
 stralloc line = {0};
 
-void main()
+int main()
 {
  int channel;
  int match;
@@ -118,7 +119,7 @@
  if (chdir("queue") == -1) die_chdir();
  readsubdir_init(&rs,"info",die_opendir);
 
- while (x = readsubdir_next(&rs,&id))
+ while ((x = readsubdir_next(&rs,&id)))
    if (x > 0)
     {
      fmtqfn(fnmess,"mess/",id,1);
@@ -133,7 +134,7 @@
 
      fd = open_read(fninfo);
      if (fd == -1) { err(id); continue; }
-     substdio_fdbuf(&ss,read,fd,inbuf,sizeof(inbuf));
+     substdio_fdbuf(&ss,subread,fd,inbuf,sizeof(inbuf));
      if (getln(&ss,&sender,&match,0) == -1) die_nomem();
      if (fstat(fd,&st) == -1) { close(fd); err(id); continue; }
      close(fd);
@@ -172,4 +173,5 @@
     }
 
  die(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/qmail-qstat.sh qmail-1.03-ldap-20060201-orig/qmail-qstat.sh
--- qmail-1.03-orig/qmail-qstat.sh	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-qstat.sh	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,13 @@
 cd QMAIL
 messdirs=`echo queue/mess/* | wc -w`
 messfiles=`find queue/mess/* -print | wc -w`
+if test -d "queue/todo/0"
+then
+tododirs=`echo queue/todo/* | wc -w`
+todofiles=`find queue/todo/* -print | wc -w`
+else
 tododirs=`echo queue/todo | wc -w`
 todofiles=`find queue/todo -print | wc -w`
+fi
 echo messages in queue: `expr $messfiles - $messdirs`
 echo messages in queue but not yet preprocessed: `expr $todofiles - $tododirs`
diff -ruN qmail-1.03-orig/qmail-queue.c qmail-1.03-ldap-20060201-orig/qmail-queue.c
--- qmail-1.03-orig/qmail-queue.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/qmail-queue.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,5 +1,6 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
 #include "readwrite.h"
 #include "sig.h"
 #include "exit.h"
@@ -20,6 +21,19 @@
 #define DEATH 86400 /* 24 hours; _must_ be below q-s's OSSIFIED (36 hours) */
 #define ADDR 1003
 
+#ifdef BIGBROTHER
+#include "byte.h"
+#include "constmap.h"
+#include "control.h"
+#include "stralloc.h"
+
+int bbon = 0;
+stralloc bbs = {0};
+stralloc bbaddr = {0};
+struct constmap mapbb;
+
+#endif
+
 char inbuf[2048];
 struct substdio ssin;
 char outbuf[256];
@@ -57,6 +71,9 @@
 void die(e) int e; { _exit(e); }
 void die_write() { cleanup(); die(53); }
 void die_read() { cleanup(); die(54); }
+#ifdef BIGBROTHER
+void die_bb() { cleanup(); die(51); }
+#endif
 void sigalrm() { /* thou shalt not clean up here */ die(52); }
 void sigbug() { die(81); }
 
@@ -151,14 +168,30 @@
 
 char tmp[FMT_ULONG];
 
-void main()
+int main()
 {
  unsigned int len;
  char ch;
+#ifdef BIGBROTHER
+ unsigned int xlen, n;
+ char *x;
+ const char *b;
+#endif
 
  sig_blocknone();
  umask(033);
  if (chdir(auto_qmail) == -1) die(61);
+
+#ifdef BIGBROTHER
+ if (control_init() == -1) die(55);
+ switch (control_readfile(&bbs,"control/bigbrother",0))
+  {
+   case -1: die(55);
+   case 0: bbon = 0; if (!constmap_init(&mapbb,"",0,1)) die(51); break;
+   case 1: bbon = 1; if (!constmap_init(&mapbb,bbs.s,bbs.len,1)) die(51); break;
+  } 
+#endif
+ 
  if (chdir("queue") == -1) die(62);
 
  mypid = getpid();
@@ -180,15 +213,20 @@
 
  messnum = pidst.st_ino;
  messfn = fnnum("mess/",1);
+#ifndef BIGTODO
  todofn = fnnum("todo/",0);
  intdfn = fnnum("intd/",0);
+#else
+ todofn = fnnum("todo/",1);
+ intdfn = fnnum("intd/",1);
+#endif
 
  if (link(pidfn,messfn) == -1) die(64);
  if (unlink(pidfn) == -1) die(63);
  flagmademess = 1;
 
- substdio_fdbuf(&ssout,write,messfd,outbuf,sizeof(outbuf));
- substdio_fdbuf(&ssin,read,0,inbuf,sizeof(inbuf));
+ substdio_fdbuf(&ssout,subwrite,messfd,outbuf,sizeof(outbuf));
+ substdio_fdbuf(&ssin,subread,0,inbuf,sizeof(inbuf));
 
  if (substdio_bput(&ssout,received,receivedlen) == -1) die_write();
 
@@ -205,8 +243,8 @@
  if (intdfd == -1) die(65);
  flagmadeintd = 1;
 
- substdio_fdbuf(&ssout,write,intdfd,outbuf,sizeof(outbuf));
- substdio_fdbuf(&ssin,read,1,inbuf,sizeof(inbuf));
+ substdio_fdbuf(&ssout,subwrite,intdfd,outbuf,sizeof(outbuf));
+ substdio_fdbuf(&ssin,subread,1,inbuf,sizeof(inbuf));
 
  if (substdio_bput(&ssout,"u",1) == -1) die_write();
  if (substdio_bput(&ssout,tmp,fmt_ulong(tmp,uid)) == -1) die_write();
@@ -223,6 +261,9 @@
   {
    if (substdio_get(&ssin,&ch,1) < 1) die_read();
    if (substdio_put(&ssout,&ch,1) == -1) die_write();
+#ifdef BIGBROTHER
+   if (bbon) if (!stralloc_catb(&bbaddr, &ch, 1)) die_bb();
+#endif
    if (!ch) break;
   }
  if (len >= ADDR) die(11);
@@ -239,16 +280,39 @@
     {
      if (substdio_get(&ssin,&ch,1) < 1) die_read();
      if (substdio_bput(&ssout,&ch,1) == -1) die_write();
+#ifdef BIGBROTHER
+     if (bbon) if (!stralloc_catb(&bbaddr, &ch, 1)) die_bb();
+#endif
      if (!ch) break;
     }
    if (len >= ADDR) die(11);
   }
-
+ 
+#ifdef BIGBROTHER
+ if (bbon) {
+   x = bbaddr.s;
+   xlen = bbaddr.len;
+   do
+    {
+     n = byte_chr(x,xlen,0);
+     if ((b = constmap(&mapbb, x, n))) {
+       if (*b) {
+         if (substdio_bput(&ssout,"T", 1) == -1) die_write();
+         if (substdio_bputs(&ssout,b) == -1) die_write();
+         if (substdio_bput(&ssout,"",1) == -1) die_write();
+       }
+     }
+     if (n++ >= xlen) break;
+     x += n; xlen -= n;
+    } while (xlen > 0);
+ }
+#endif
+ 
  if (substdio_flush(&ssout) == -1) die_write();
  if (fsync(intdfd) == -1) die_write();
 
  if (link(intdfn,todofn) == -1) die(66);
 
  triggerpull();
- die(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/qmail-quotawarn.c qmail-1.03-ldap-20060201-orig/qmail-quotawarn.c
--- qmail-1.03-orig/qmail-quotawarn.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qmail-quotawarn.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,423 @@
+/*
+ * Copyright (c) 1999-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <dirent.h>
+#include <unistd.h>
+
+#include "auto_qmail.h"
+#include "byte.h"
+#include "case.h"
+#include "control.h"
+#include "date822fmt.h"
+#include "datetime.h"
+#include "env.h"
+#include "error.h"
+#include "exit.h"
+#include "fmt.h"
+#include "getln.h"
+#include "mailmagic.h"
+#include "myctime.h"
+#include "newfield.h"
+#include "now.h"
+#include "open.h"
+#include "qmail-ldap.h"
+#include "readwrite.h"
+#include "seek.h"
+#include "sig.h"
+#include "str.h"
+#include "strerr.h"
+#include "stralloc.h"
+#include "substdio.h"
+#include "wait.h"
+#include "lock.h"
+
+/* global vars */
+stralloc warning = {0};
+stralloc me = {0};
+stralloc to = {0};
+stralloc from = {0};
+stralloc subject = {0};
+stralloc header = {0};
+stralloc qwline = {0};
+stralloc temp = {0};
+
+#define FATAL "qmail-quotawarn: fatal: "
+#define WARN  "qmail-quotawarn: warn: "
+
+void
+temp_nomem(void)
+{
+	strerr_die2x(111, FATAL, "Out of memory.");
+}
+void
+temp_qmail(char *fn)
+{
+	strerr_die4sys(111, FATAL, "Unable to open ", fn, ": ");
+}
+void
+temp_rewind(void)
+{
+	strerr_die2x(111, FATAL, "Unable to rewind message.");
+}
+void
+temp_slowlock()
+{
+	strerr_die2x(111, FATAL, 
+	    "File has been locked for 30 seconds straight. (#4.3.0)");
+}
+
+void check_maildir(void);
+void write_maildir(void);
+void check_mailfile(char* fn);
+void write_mailfile(char* fn);
+
+void
+readcontrol(void)
+{
+	int	fddir;
+
+	fddir = open_read(".");
+	if (fddir == -1)
+		strerr_die2sys(111, FATAL, "Unable to open cwd: ");
+	if (chdir(auto_qmail) == -1)
+		strerr_die4sys(111, FATAL, "Unable to switch to ",
+		    auto_qmail, ": ");
+
+	if (control_init() == -1)
+		strerr_die2sys(111, FATAL, "Unable to read controls: ");
+	if (control_readline(&me, "control/me") != 1)
+		strerr_die2sys(111, FATAL, "Unable to read control/me: ");
+	if (control_readrawfile(&warning, "control/quotawarning") == -1)
+		strerr_die2sys(111, FATAL,
+		    "Unable to read control/quotawarning: ");
+	else if (warning.len == 0)
+		_exit(0);
+	
+	if (fchdir(fddir) == -1)
+		strerr_die2sys(111,FATAL,"unable to switch back to cwd: ");
+	close(fddir);
+}
+
+int
+main(int argc, char **argv) 
+{
+	char *s;
+	char *fn;
+
+
+	if(!argv[1] || argv[2]) 
+		strerr_die1x(100,
+		    "qmail-quotawarn: usage: qmail-quotawarn mailbox.");
+
+	fn = argv[1];
+
+	readcontrol();
+	
+	if (!env_init()) temp_nomem();
+	if (!(s = env_get("USER")))
+		strerr_die1x(100, "UESR environment not present.");  
+	if (!stralloc_copys(&qwline, "Qmail-QuotaWarning: ")) temp_nomem();
+	if (!stralloc_cats(&qwline, s)) temp_nomem();
+	if (!stralloc_append(&qwline, "@")) temp_nomem();
+	if (!(s = env_get("HOST")))
+		strerr_die1x(100, "HOST environment not present.");  
+	if (!stralloc_cats(&qwline, s)) temp_nomem();
+	if (!stralloc_append(&qwline, "\n")) temp_nomem();
+
+	if (fn[str_len(fn)-1] == '/') {
+		if (chdir(fn) == -1)
+			strerr_die3sys(111, "Unable to switch to ", fn, ": ");
+		check_maildir();
+		write_maildir();
+	} else {
+		check_mailfile(fn);
+		write_mailfile(fn);
+	}
+	/* NOTREACHED */
+	return 1;
+}
+
+static char timebuf[DATE822FMT];
+
+struct mheader mheader[] = {
+	{ "From:", 0, ALLOW, 0 },
+	{ "To:", 0, FORCE, 0 },
+	{ "Subject:", "QUOTA-WARNING!\n", ALLOW, 0 },
+	{ "MIME-Version:", "1.0", FORCE, 0 },
+	{ "Content-Type:", "text/plain; charset=\"iso-8859-1\"\n", ALLOW, 0 },
+	{ "Content-Transfer-Encoding:", "8bit", ALLOW, 0 },
+	{ "X-", 0, ALLOW, 0 },
+	{ DEFAULT, 0, DENY, 0 },
+	{ 0, 0, 0, 0 }
+};
+
+int
+writemail(substdio *ssout, datetime_sec starttime)
+{
+	struct datetime dt;
+	char *t;
+	int offset;
+
+	/* store default To: From: Subject: */
+	if (! (t = env_get("RECIPIENT")))
+		strerr_die2x(111, FATAL, "RECIPIENT not present");
+	mheader[1].v = t;
+
+	if (!stralloc_copys(&from, "Qmail-QUOTAGUARD <MAILER-DAEMON@"))
+		temp_nomem();
+	if (!stralloc_cat(&from, &me)) temp_nomem();
+	if (!stralloc_cats(&from, ">\n")) temp_nomem();
+	if (!stralloc_0(&from)) temp_nomem();
+	mheader[0].v = from.s;
+	
+	
+	offset = headermagic(&warning, &header, 0, mheader);
+	if (offset == -1) {
+		if (errno == error_nomem) temp_nomem();
+		return 0;
+	}
+
+	/*
+	 * start writing header, first set:
+	 * Return-Path: Delivered-to: Qmail-QuotaWarning:
+	 * Received: Message-ID: Date:
+	 */
+	if (substdio_puts(ssout, "Return-Path: <>\n") == -1) return 0;
+
+	if (!(t = env_get("DTLINE")))
+		strerr_die2x(111, FATAL, "DTLINE not present");
+	if (substdio_puts(ssout, t) == -1) return 0;
+	/* Qmail-QuotaWarning: line */
+	if (substdio_put(ssout, qwline.s, qwline.len)) return 0;
+	/* Received: line */
+	if (substdio_puts(ssout,
+		    "Received: (directly through the "
+		    "qmail-quotawarning program);\n\t"))
+		return 0;
+	datetime_tai(&dt, starttime);
+	if (substdio_put(ssout, timebuf, date822fmt(timebuf, &dt))) return 0;
+	
+	/* message-id and date line */
+	if (!newfield_datemake(starttime)) temp_nomem();
+	if (!newfield_msgidmake(me.s, me.len, starttime)) temp_nomem();
+	if (substdio_put(ssout, newfield_msgid.s, newfield_msgid.len))
+		return 0;
+	if (substdio_put(ssout, newfield_date.s, newfield_date.len))
+		return 0;
+	
+	
+	/* To: From: and Subject: */
+	if (substdio_put(ssout, header.s, header.len)) return 0;
+	/* don't forget the single \n */
+	if (substdio_puts(ssout, "\n")) return 0;
+	/* the Warning */
+	if (substdio_put(ssout, warning.s + offset, warning.len - offset))
+		return 0;
+	if (warning.s[warning.len-1] == '\n')
+		if (substdio_bputs(ssout, "\n")) return 0;
+	
+	return 1;
+}
+
+void
+check_maildir(void)
+{
+	char const *(dirs[2]);
+	DIR *folder;
+	struct dirent *entry;
+	int i;
+	unsigned int j;
+
+	dirs[0]="new"; dirs[1]="cur"; 
+	for (i=0; i<2; i++) {
+		/* checking for old mail */
+		if ((folder = opendir(dirs[i])) == 0)
+			strerr_die3sys(111, "Unable to opendir ", dirs[i], ": ");
+		while ((entry = readdir(folder)) != 0) {
+			if (*entry->d_name == '.') continue;
+			j = str_rchr(entry->d_name, '.');
+			if (entry->d_name[j++] == '\0') continue;
+			if (!str_diffn("QUOTA_WARNING", &entry->d_name[j], 13))
+				_exit(0);
+		}
+		closedir(folder);
+	}
+}
+
+char fntmptph[80 + FMT_ULONG * 2];
+char fnnewtph[83 + FMT_ULONG * 3];
+void tryunlinktmp(void) { unlink(fntmptph); }
+void sigalrm(void)
+{
+	tryunlinktmp();
+	strerr_die1x(111, "Timeout on quota-warning delivery.");
+}
+
+char buf[1024];
+
+void
+write_maildir(void)
+{
+	char *s;
+	int loop;
+	int pid;
+	int fd;
+	datetime_sec starttime;
+	struct stat st;
+	substdio ssout;
+
+	sig_alarmcatch(sigalrm);
+
+	pid = getpid();
+	starttime = now();
+	for (loop = 0;;++loop) {
+		s = fntmptph;
+		s += fmt_str(s, "tmp/");
+		s += fmt_ulong(s, starttime); *s++ = '.';
+		s += fmt_ulong(s, pid); *s++ = '.';
+		s += fmt_str(s, "QUOTA_WARNING"); 
+		*s++ = 0;
+		if (stat(fntmptph, &st) == -1) if (errno == error_noent) break;
+		/* really should never get to this point */
+		if (loop == 2)
+			strerr_die2sys(111, FATAL, "Could not stat tmp file: ");
+		sleep(2);
+	}
+	str_copy(fnnewtph, fntmptph);
+	byte_copy(fnnewtph, 3, "new");
+
+	alarm(86400);
+	fd = open_excl(fntmptph);
+	if (fd == -1)
+		strerr_die2sys(111, FATAL, "Unable to open tmp file: ");
+
+	substdio_fdbuf(&ssout, subwrite, fd, buf, sizeof(buf));
+	if (writemail(&ssout, starttime) == 0) goto fail;
+	if (substdio_flush(&ssout) == -1) goto fail;
+
+	if (fsync(fd) == -1) goto fail;
+	if (fstat(fd, &st) == -1) goto fail;
+	if (close(fd) == -1) goto fail; /* NFS dorks */
+
+	s = fnnewtph;
+	while( *s ) s++;
+	s += fmt_str(s, ",S=");
+	s += fmt_ulong(s, (unsigned long) st.st_size);
+	*s++ = 0;
+
+	if (link(fntmptph, fnnewtph) == -1)
+		/* if error_exist unlink and exit(0),
+		 * strange things can happen */
+		if ( errno != error_exist) goto fail;
+
+	tryunlinktmp();
+	_exit(0);
+
+fail:
+	strerr_warn2(FATAL, "Writing Quota-Warning to maildir failed: ",
+	    &strerr_sys);
+	tryunlinktmp();
+	_exit(111);
+}
+
+void
+check_mailfile(char* fn)
+{
+	int fd;
+	int match;
+	substdio ss;
+
+	fd = open_read(fn);
+	if (seek_begin(fd) == -1) temp_rewind();
+
+	substdio_fdbuf(&ss, subread, fd, buf, sizeof(buf));
+	do {
+		if(getln(&ss, &temp, &match, '\n') != 0) {
+			strerr_warn2(WARN, "Unable to read message: ",
+			    &strerr_sys);
+			break;
+		}
+		if (temp.len == qwline.len)
+			if (!case_diffb(qwline.s, qwline.len, temp.s)) {
+				/* quota warning already in mailbox */
+				close(fd);
+				_exit(0);
+			}
+	} while (match);
+	/* no quota warning found */
+	close(fd);
+}
+
+void
+write_mailfile(char* fn)
+{
+	int fd;
+	substdio ssout;
+	seek_pos pos;
+	int flaglocked;
+	datetime_sec starttime;
+
+	starttime = now();
+
+	fd = open_append(fn);
+	if (fd == -1)
+		strerr_die4sys(111, FATAL, "Unable to open ", fn, ": ");
+
+	sig_alarmcatch(temp_slowlock);
+	alarm(30);
+	flaglocked = (lock_ex(fd) != -1);
+	alarm(0);
+	sig_alarmdefault();
+
+	seek_end(fd);
+	pos = seek_cur(fd);
+
+	substdio_fdbuf(&ssout, subwrite, fd, buf, sizeof(buf));
+	if (substdio_puts(&ssout, "From MAILER-DAEMON ")) goto writeerrs;
+	if (substdio_puts(&ssout, myctime(starttime))) goto writeerrs;
+	if (writemail(&ssout, starttime) == 0) goto writeerrs;
+	if (substdio_bputs(&ssout, "\n")) goto writeerrs;
+	if (substdio_flush(&ssout)) goto writeerrs;
+	if (fsync(fd) == -1) goto writeerrs;
+	close(fd);
+	_exit(0);
+
+writeerrs:
+	strerr_warn4(FATAL, "Unable to write ", fn, ": ", &strerr_sys);
+	if (flaglocked) seek_trunc(fd, pos);
+	close(fd);
+	_exit(111);
+}
+
